// Code generated by go-swagger; DO NOT EDIT.

package metadata

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewOrgAccountOverviewParams creates a new OrgAccountOverviewParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgAccountOverviewParams() *OrgAccountOverviewParams {
	return &OrgAccountOverviewParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgAccountOverviewParamsWithTimeout creates a new OrgAccountOverviewParams object
// with the ability to set a timeout on a request.
func NewOrgAccountOverviewParamsWithTimeout(timeout time.Duration) *OrgAccountOverviewParams {
	return &OrgAccountOverviewParams{
		timeout: timeout,
	}
}

// NewOrgAccountOverviewParamsWithContext creates a new OrgAccountOverviewParams object
// with the ability to set a context for a request.
func NewOrgAccountOverviewParamsWithContext(ctx context.Context) *OrgAccountOverviewParams {
	return &OrgAccountOverviewParams{
		Context: ctx,
	}
}

// NewOrgAccountOverviewParamsWithHTTPClient creates a new OrgAccountOverviewParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgAccountOverviewParamsWithHTTPClient(client *http.Client) *OrgAccountOverviewParams {
	return &OrgAccountOverviewParams{
		HTTPClient: client,
	}
}

/*
OrgAccountOverviewParams contains all the parameters to send to the API endpoint

	for the org account overview operation.

	Typically these are written to a http.Request.
*/
type OrgAccountOverviewParams struct {

	// AccountEmail.
	AccountEmail string

	// OrganizationToken.
	OrganizationToken string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org account overview params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgAccountOverviewParams) WithDefaults() *OrgAccountOverviewParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org account overview params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgAccountOverviewParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org account overview params
func (o *OrgAccountOverviewParams) WithTimeout(timeout time.Duration) *OrgAccountOverviewParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org account overview params
func (o *OrgAccountOverviewParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org account overview params
func (o *OrgAccountOverviewParams) WithContext(ctx context.Context) *OrgAccountOverviewParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org account overview params
func (o *OrgAccountOverviewParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org account overview params
func (o *OrgAccountOverviewParams) WithHTTPClient(client *http.Client) *OrgAccountOverviewParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org account overview params
func (o *OrgAccountOverviewParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountEmail adds the accountEmail to the org account overview params
func (o *OrgAccountOverviewParams) WithAccountEmail(accountEmail string) *OrgAccountOverviewParams {
	o.SetAccountEmail(accountEmail)
	return o
}

// SetAccountEmail adds the accountEmail to the org account overview params
func (o *OrgAccountOverviewParams) SetAccountEmail(accountEmail string) {
	o.AccountEmail = accountEmail
}

// WithOrganizationToken adds the organizationToken to the org account overview params
func (o *OrgAccountOverviewParams) WithOrganizationToken(organizationToken string) *OrgAccountOverviewParams {
	o.SetOrganizationToken(organizationToken)
	return o
}

// SetOrganizationToken adds the organizationToken to the org account overview params
func (o *OrgAccountOverviewParams) SetOrganizationToken(organizationToken string) {
	o.OrganizationToken = organizationToken
}

// WriteToRequest writes these params to a swagger request
func (o *OrgAccountOverviewParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param accountEmail
	if err := r.SetPathParam("accountEmail", o.AccountEmail); err != nil {
		return err
	}

	// path param organizationToken
	if err := r.SetPathParam("organizationToken", o.OrganizationToken); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
